
package de.ivu.elect.presentation.wahlbeteiligung.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertung;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.replikation.ReplikationPresentationStatus;
import de.ivu.elect.presentation.wahlbeteiligung.WahlbeteiligungAuswertungEditView;

@Named(WahlbeteiligungAuswertungEditAction.COMPONENT_NAME)
public class WahlbeteiligungAuswertungEditAction extends AbstractWahlbeteiligungAuswertungAction {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlbeteiligungAuswertungEditAction";

  @View
  @Inject
  private WahlbeteiligungAuswertungEditView wahlbeteiligungAuswertungEditView;

  @Inject
  private transient ReplikationPresentationStatus replikationPresentationStatus;

  @Override
  public boolean isDisabledInternal(@Nonnull WahlbeteiligungAuswertung wahlbeteiligungAuswertung) {
    return super.isDisabledInternal(wahlbeteiligungAuswertung) || isSlave();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.WAHLBETEILIGUNG_AUSWERTUNG_EDIT;
  }

  @Override
  protected String doIt(WahlbeteiligungAuswertung wahlbeteiligungAuswertung) {
    return wahlbeteiligungAuswertungEditView.edit(wahlbeteiligungAuswertung);
  }

  @Override
  protected boolean isFireChangeEvent() {
    return false;
  }

  @Override
  public String getLabelKey() {
    return "entity.edit.action.edit";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconEdit();
  }

  private boolean isSlave() {
    return replikationPresentationStatus.isSlave();
  }
}
